//*******************************************************
//@ohbPQkePWQQ jLV[ǎvpRvOiVAԊOʐMɂj
//   PIC12LF1822 Remote Control for Nixie Clock( with Serial IR Tranciever)
//
//  file name: main.c
//
//@@傫ȃ^NgXCb`irQjƕʂ̃^NgXCb`irPjꂽ
//    DSM(Digital Signal Modurator)ŕΏd̃VAMo͂
//@@UOOaor@WmP
//
//   MPLAB IDE v8.84  HiTEC C
//   
//   VAԊOʐMvOɏCB
//
//   X[v̏d͖W`i12LF1822 gKvLj
//
//  2017/10/21  New (TAB4) Taishi
//*******************************************************

#include	<htc.h>

#include	"12LF1822_nixie_remote.h"

// CONFIG for 12LF1822

__CONFIG (	FCMEN_OFF			//	0(OFF) = tFCZ[t NbNj^𖳌ɂ
		&	IESO_OFF			//	0(OFF) = tFCZ[t NbNj^𖳌ɂ
		&	CLKOUTEN_OFF		//	1(OFF) = CLKOUT@\𖳌ɂBCLKOUT sI/O Ƃċ@\
		&	BOREN_ON			//	11 = BOR(uEAEgZbg)Lɂ
		&	CPD_OFF				//	1(OFF) = f[^̃R[hی𖳌ɂ
		&	CP_OFF				//	1(OFF) = vÕR[hی𖳌ɂ
		&	MCLRE_ON			//	1(ON) = MCLR/VPP s͂lbkq͂Ƃċ@\B
		&	PWRTE_ON			//	0 = PWRT(p[Abv^C}[)Lɂ
		&	WDTE_OFF			//	00 = WDT(EHb`hbO^C}[)𖳌ɂ
		&	FOSC_INTOSC			//	100 = INTOSCIV[^:CLKIN sI/O Ƃċ@\
);

								//	fobO@\͏ݑuɔCij

__CONFIG (	LVP_OFF				//	0(OFF)=vO~OMCLR ɍdKv
		&	BORV_LO				//	1 = uEAEgZbgd(Vbor)̃gbv|Cgɐݒ肷
		&	STVREN_ON			//	1(ON) = X^bÑI[o[t[܂̓A_[t[ɂăZbg𔭐
		&	PLLEN_ON			//	1 = 4xPLL Lɂ
		&	WRT_OFF				//	11 = ݕیOFF ɂ
);

char	str_sxxe[2][4][5]={			// s11e  s88e ܂ł̃f[^
		{
			{'s','1','1','e',0x00},		// s11e Mf[^ set n߂
			{'s','2','2','e',0x00},		// s22e Mf[^ set A
			{'s','3','3','e',0x00},		// s33e Mf[^ set Z
			{'s','4','4','e',0x00},		// s44e Mf[^ set 
		},
		{
			{'s','5','5','e',0x00},		// s55e Mf[^ select n߂
			{'s','6','6','e',0x00},		// s66e Mf[^ select A
			{'s','7','7','e',0x00},		// s77e Mf[^ select Z
			{'s','8','8','e',0x00},		// s88e Mf[^ select 
		},
};

// M@UOOaor
void	tx_600_char(char c)
{
	unsigned char	i;
	unsigned char	b=0x01;

	MDBIT = 0;					// X^[grbg
	__delay_us(1666);			//	1.666ҋ@;

	for(i=0;i<8;i++,b <<= 1){	// f[^rbg
		if((c & b)==0){
			MDBIT = 0;
		}else{
			MDBIT = 1;
		}
		__delay_us(1666);		//	1.666ҋ@;
	}

	MDBIT = 1;					// Xgbvrbg
	__delay_us(1666);			//	1.666ҋ@;

}

//  M@UOOaor
//   @Fi|C^[j^[~l[^͂OOO
void	tx_600_str(char *s)
{
	while(*s != 0x00){
		tx_600_char(*s);		// M@UOOaor
		s++;
	}
}

// XCb`ꂽ̏
//   @FXCb`ԍiP  Qj
void	proc_switch_on(unsigned char n)
{
	unsigned char	renzoku_count;		// Af[^Ԋui̒l x 10msj
	unsigned char	on_jikan;			// 10mS x ̒lĂԂɂȂ

	if((n == 1) || (n == 2)){
		MDEN = 1;						// W[FL
		RA4 = 0;						// LED ON
		tx_600_str(&str_sxxe[n-1][0][0]);	// n߂ M
		RA4 = 1;						// LED OFF
		renzoku_count = 100;			// ŏ̘Af[^Ԋui1sj
		on_jikan = 0;					// 10mS x ̒lĂԂɂȂ

		while(1){
			if(n == 1){					// XCb`P̎
				if(RA1 != 0){			// S1:high
					__delay_ms(20);		//	QOҋ@;
					if(RA1 != 0){		// S1:high Qx@{high
						break;
					}
				}
			}else{						// XCb`Q̎
				if(RA2 != 0){			// S2:high
					__delay_ms(20);		//	QOҋ@;
					if(RA2 != 0){		// S2:high Qx@{high
						break;
					}
				}
			}
			__delay_ms(10);				//	POҋ@;
			if(renzoku_count == 0){		// ŏ̘Af[^ԊuO̎
				renzoku_count = 50;
				RA4 = 0;						// LED ON
				tx_600_str(&str_sxxe[n-1][1][0]);	// A M
				RA4 = 1;						// LED OFF
			}else{
				renzoku_count--;		// Af[^Ԋu|P
			}
			if(on_jikan < 255){			// ĂԃJE^[QTT̎
				on_jikan++;				// ĂԃJE^[{P
			}
		}

		RA4 = 0;						// LED ON
		if(on_jikan <= 100){			// ĂԂPbȉ̎
			tx_600_str(&str_sxxe[n-1][2][0]);	// Z M
		}else{
			tx_600_str(&str_sxxe[n-1][3][0]);	//  M
		}
		RA4 = 1;						// LED OFF

		MDEN = 0;						// W[F
	}
}

// 
void	main(void)
{
	unsigned char	i;

	di();						//	荞݋֎~

//				76543210
	OSCCON	= 0b01110000;		//	NbNWlg@c@okkHLȂ̂ŎRQlg
	OPTION_REG &= 0b01111111;	// Ŝ̃vAbvLɂ

//				76543210		//  |[g`
	ANSELA	= 0b00000000;		//	ăfW^óiAiO͋֎~j
	PORTA	= 0b00010000;		//	o̓f[^ݒ(RA4:1 other:0)
	TRISA	= 0b00101110;		//	o͕ݒ(RA5,3,2,1:)
	WPUA	= 0b00101110;		//	vAbvݒ(RA5,3,2,1:vAbvL)

	for(i=0;i<8;i++){
		PORTA ^= 0x11;			//  LED ON or OFF
		__delay_ms(500);		//	TOOҋ@;
	}

	// Timer1 Init. gȂ
	T1CON  = 0b00000000;		// Fosc/4, prescaler 1:1, timer1osc:dis, sync Fosc, ~
	T1GCON = 0b00000000;		// Timer1 Not Link Gate
	TMR1H  = 0;					// Uper Reg
	TMR1L  = 0;					// Lower Reg

	// DSM(Digital Signal Modurator) ̐ݒ@inm^neeL[COj

	//  bboPgɂāAlcahsMi\tgjϒMƂ
	//    o͔]ĂȂA̔guŁ@k̔gbboPiovljȂ̂Ł@
	//    ϒM ̎͂kóAk͕̎ϒMiovljoB
	MDCON  = 0b01000001;		// W[Aso͂͗LAX[[gAo͔]ȂAlcahs͔gggp
	MDSRC  = 0b10000000;		// W[^M̏o̓sFAW[^MFMDBIT
	MDCARH = 0b10000000;		// Ig̏o̓sFAggFVss
	MDCARL = 0b10000100;		// Ig̏o̓sFAkgFCCP1(PWM)


	// 38KHz ̔g`o  26.32uSAFosc/4(8MHz) ŃJEg 210 ɂȂ
	//  ^C}[QJEg^C}[ɂȂ
	T2CON= 0b00000000;			// |XgXP[1:1A܂~AvXP[P
	TMR2    = 0;				// ^C}[l[NAilj
	PR2 = 210;					// 38kHz

	// CCP1 Init.
	CCPR1L = PR2/2;				// 50:50 PWMf[eBig̎ԁj
	CCP1CON = 0b00001100;		// PWM[hVOo
	TMR2ON  = 1;				// ^C}[QX^[g

	MDMSODIS = 0;				// MSD X^[g

// Remote Control
	while(1){
		if(RA2 == 0){					// S2:Low
			__delay_ms(20);				//	QOҋ@;
			if(RA2 == 0){				// S2:Low Qx@{Low
				proc_switch_on(2);		// XCb`ꂽ̏
			}
		}

		if(RA1 == 0){					// S1:Low
			__delay_ms(20);				//	QOҋ@;
			if(RA1 == 0){				// S1:Low Qx@{Low
				proc_switch_on(1);		// XCb`ꂽ̏
			}
		}

		IOCAP = 0x00;					// オGbWԕω荞݃WX^FNAiׂĖj
		IOCAN1 = 1;						// q`PGbWԕω荞݁FL
		IOCAN2 = 1;						// q`QGbWԕω荞݁FL
		IOCAF = 0x00;					// ԕω荞݃tOWX^ otONA
		IOCIE = 1;						// ԕω荞݁FL
		PEIE = 1;						// Ӌ@\荞݁FL

		SLEEP();						// 啶ɒӁII
		NOP();							// 啶ɒӁII

	}

}
